<?php

/*
  Plugin Name: Wordpress to subscribe.ru cross poster
  Plugin URI: http://zixn.ru
  Description: Публикация новых статей в вашу рассылку на subscribe.ru. Модификация от zixn.ru. Добавлен метабокс в записи с галкой об отправки записи.
  Author: Владимир Юшко (http://blogclient.ru) мод Djo 2016
  Version: 4.0
  Author URI: http://blogclient.ru/
 */

function SubscriberuAddPages() {
    add_options_page("Subscribe.ru", "Subscribe.ru", 6, __FILE__, "SubscriberuDisplayOptions");
}

function MyGetValue($Name) {
    add_option($Name);
    $Result = stripslashes(get_option($Name));
    if (isset($_REQUEST[$Name]) && ($Result != $_REQUEST[$Name])) {
        update_option($Name, $_REQUEST[$Name]);
        $Result = $_REQUEST[$Name];
    }
    return$Result;
}

function SubscriberuDisplayOptions() {
    global $wpdb;
    $SubscriberuCode = MyGetValue("SubscriberuCode");
    $SubscriberuListPassword = MyGetValue("SubscriberuListPassword");
    $SubscriberuMore = MyGetValue("SubscriberuMore");
    if (isset($_REQUEST['SubscriberuCode']) && !isset($_REQUEST['SubscriberuMore'])) {
        $SubscriberuMore = false;
        update_option('SubscriberuMore', false);
    }
    $Checked = $SubscriberuMore ? 'checked="checked"' : '';
    echo <<<EOF
		<div style="-moz-border-radius: 10px; padding: 0px 10px 0px 10px; border: 2px solid silver;">
		<form action="" method="POST">
		<br clear="all" />
Код рассылки на Subscribe.ru (пример <a href="http://subscribe.ru/catalog/comp.soft.prog.blogclient">comp.soft.prog.blogclient</a>): <input id="SubscriberuCode" name="SubscriberuCode" type="text" size="80" value="{$SubscriberuCode}" /> 
		<br clear="all" />
		Пароль рассылки на Subscribe.ru: <input id="SubscriberuListPassword" name="SubscriberuListPassword" type="password" size="80" value="{$SubscriberuListPassword}" /> 
		<br clear="all" />
<label><input id="SubscriberuMore" name="SubscriberuMore" type="checkbox" value="true" {$Checked} />Публиковать запись полностью</label>
		<br clear="all" />
		<br clear="all" /><br clear="all" />
<input type="submit" name="UPDATE" value="Обновить" style="float: right;">
		</form><br /><br clear="all" /><br clear="all" />
		</div>
EOF;
}

function SendEMailToSubscriberu($PostId) {
//prevent double message
    add_option('SubscriberuLastPostId');
    $LastPostId = stripslashes(get_option('SubscriberuLastPostId'));
    if ($PostId <= $LastPostId)
        return $PostId;
    update_option('SubscriberuLastPostId', $PostId);

    $SubscriberuCode = stripslashes(get_option("SubscriberuCode"));
    $SubscriberuListPassword = get_option("SubscriberuListPassword");
    $SubscriberuMore = get_option("SubscriberuMore");

    $Post = & get_post($PostId);
    $Subject = apply_filters('the_title', $Post->post_title);
    $From = get_option('admin_email');
    $Date = gmdate("M d Y H:i:s", time());

    if (strpos($Post->post_content, "<!--more-->") === false) {
        $Body = apply_filters('the_content', $Post->post_content);
    } else {
        $content = explode("<!--more-->", $Post->post_content, 2);
        $Body = apply_filters('the_content', $content[0]);
        if ($SubscriberuMore)
            $Body .= apply_filters('the_content', $content[1]);
    }
    $Body .= '<p><a href="' . get_permalink($PostId) . '">Полный текст обзора...</a>.</p>';
    if (!(empty($SubscriberuCode) && empty($SubscriberuListPassword))) {
//@@TEST@@
        $Text = "@@NAME@@ $SubscriberuCode
@@PASSWD@@ $SubscriberuListPassword
@@CHARSET@@ кошка
@@SUBJ@@ $Subject
@@BEGINHTML@@
$Body
@@ENDHTML@@\n";

        $Text = @iconv('UTF-8', 'koi8-r//ignore', $Text);
        mail('issue@subscribe.ru', 'news', $Text, "From: $From
Content-Type: text/plain; charset=\"koi8-r\"
Content-Transfer-Encoding: 8bit
MIME-Version: 1.0
Date: $Date
Reply-To: $From
X-Priority: 3
X-Mailer: Wordpress to subscribe.ru cross poster");
    }
    return $PostId;
}

add_action('admin_menu', 'SubscriberuAddPages');
//20.12.2016 zixn.ru
//add_meta_box('subscribe-metabox', 'Subscribe', 'metabosHtml', "posts", 'side', 'high');
add_action('add_meta_boxes_post', 'setMetabos');

function setMetabos($post) {
    add_meta_box('subscribe-meta-box', 'Subscribe', 'metabosHtml', 'post', 'side', 'high');
}

function metabosHtml($post) {
// Используем nonce для верификации
    wp_nonce_field(plugin_basename(__FILE__), 'subscribe_noncename');
// Поля формы для введения данных

    if (get_post_meta($post->ID, '_subscribe_sent', true) == 'on') {
        $cheked0 = 'checked';
    } else {
        $cheked0 = '';
    }
    echo '<input type="checkbox" name="subscribe_field_check" ' . $cheked0 . '/>';
    echo '<span class="description">Отправить в Subscribe</span>';
    echo '<input type="hidden" id="SubscribePostID" value="' . $post->ID . '" />';
}

add_action('save_post', 'metaboxSavePost'); //Сохранение галки в постах
add_action('publish_post', 'metaboxSavePost'); //Сохранение галки в постах

function metaboxSavePost($post_id) {

// проверяем nonce нашей страницы, потому что save_post может быть вызван с другого места.
    if (isset($_POST['subscribe_noncename'])) {
        if (!wp_verify_nonce($_POST['subscribe_noncename'], plugin_basename(__FILE__))) {
            return $post_id;
        }
    }

// проверяем, если это автосохранение ничего не делаем с данными нашей формы.
    if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)
        return $post_id;

// проверяем разрешено ли пользователю указывать эти данные
    if (!current_user_can('edit_post', $post_id)) {
        return $post_id;
    }

    if (isset($_POST['subscribe_field_check'])) {
        $data0 = $_POST['subscribe_field_check']; // Данные о галке отправки/неотправки
        update_post_meta($post_id, '_subscribe_sent', $data0);
    } else {
        delete_post_meta($post_id, '_subscribe_sent');
    }
}

add_action('publish_post', 'sentSubscirbe', 20);

function sentSubscirbe($postId) {

    if (get_post_meta($postId, '_subscribe_sent', true) == 'on') {
        SendEMailToSubscriberu($postId); //Отправка старой функцией
        //echo "hell1";
        //exit();
    } else {
        
    }
}

?>